OA
Storage Moving. 这题很简单,Python用好Counter直接秒。。
Stock Price. 连续K个月没有相同股价的组合里,最大的是多少。也是地理原题,用移动窗口。
channels quality You are given a list of packets of varying sizes and there are n channels. Each of the n channel must have a single packet Each packet can only be on a single channel The quality of a channel is described as the median of the packet sizes on that channel. The total quality is defined as sum of the quality of all channels (round to integer in case of float). Given the packets and channels find the maximum quality. 注意的地方是,有不少test cases是会造成溢出的,所以要处理好
Alexa find nearby restaurant L973 https://leetcode.com/problems/k-closest-points-to-origin/ 变形 找最近点
记得是prime day,然后方法和上一题类似 用default dict 做的长度对应array
maxAggregatetemperature() 给你一个气温的Arr 表示每天的温度。每一天的max_aggregate_temp() 是这一天加上之前所有天的温度和这一天加上之后所有天的温度的max。 最后返回所有天数中最大的max_aggregate_temp。 e.g. 输入: [6,-2,5] 第一天max_aggregate_temp() = max(6,9) = 9 (注释: 6 = 6; 9 = 6-2+5) 第二天max_aggregate_temp() = max(4,3) = 4 (注释:4 = 6-2; 3 = -2+5) 第一天max_aggregate_temp() = max(9,5) = 9 (注释: 9 = 6-2+5; 5 = 5) 返回 max(9,4,9) = 9
卡车装货求最小的cost, 感觉这一题地里可能已经有了。描述起来也是麻烦。。。 输入: 卡车容量 k = 7, 卡车里已有的货物:[6,3,9,1,4] (5个货物,每个数字代表运送这个货物的cost) 要求:a. 卡车必须装满 (此题中剩余两个空位)b. 货物的cost是1 - infinity 正整数,cost 也同时是货物id,所以id不重复,已经装在卡车里的货物不能重复装,求装满卡车的最小的cost。 此题中可选的货物list [2,5,7,8,10,.......infinity] 因为还剩下两个空,所以选2 和5. 返回值 7 后面收到通知再update
LeetCode 918
rebuildSubString
move locations
第一题基于pascal triangle,一个倒三角,每个node是一个2位数,两两的个位数相加,最后一个取个位数 第二题很像128,有个int array问 每个group里差不超过k 分成最少的group数量是多少
oa1一个moveto movefrom,一个max股票题
刚刚2022/3/9 10pm做了intern oa1 刷了几天地里的题库 一打开是没见过的题 吓得人没了 幸好很简单 1 reverse part of the list,比如 【1,2,3,4,5】operation【【1,3】【0,3】】return【2,3,4,1,5】 2 regular expression 所有string match pattern:由a and/or b组成,头尾char一样,比如a,b,aba,baabab是true,ab是false 可能是我刷的帖子不够多没看到原题 求大佬指路 求加米还差几颗看面经家人们!
来分享一个稀里糊涂过的亚马逊oa,前几天做的hankerrank oa,第一个题是合并最重包裹,地里有的,很快就写了出来。然后卡在了第二题, 初一看题好像也是地里出现过的,就是找imbalanced group的因为题太长实在没仔细看,以为也是地里原题就啃哧啃哧写了code,结果一跑test case不对,傻眼了,system println查看了半天没发现code有什么问题,再仔细回看了下题目才发现要求的output跟之前的不一样。 题目大致是这样,给一个长度为n的数组,比如[4,1,3,2], imbalance的定义就是数组的所有subarray排序后,前后数相差>1就表示这一组是imbalance,比如上面的数组subarray有 [4], [4,1], [4,1,3], [4,1,3,2], [1,3][1,3,2][3,2]...以此类推,其中[4,1] sort 后[1,4] 4 - 1 > 1 所以是一个imbalance group,以前地里的题是算imbalance度,所以[4,1]的imbalance度是3,现在要求output是所有的subarray里有多少imbalance的case。
Find number of possible subarrays from an array , where max and min difference of elements in subarray is less than the given limit.
input : limit ,array output : return count of all possible combinations
I think I had this one. I used a TreeMap and moving a window to solve it.
Similar to this problem, instead of the max just do the counting:
https://leetcode.com/discuss/interview-question/1786827/Amazon-OA Question 1 Maximum Avarage Subtree (In The Name Of Employee Tree) Solution: Java bottom-up naive recursion solution with complexity O(N). (src-https://leetcode.com/problems/maximum-average-subtree)
Question 2 : Find The Highest Profit(MaxHeap Problem) Solution: (Same as src- https://leetcode.com/problems/sell-diminishing-valued-colored-balls/)
Q1 : Largest Area in Histogram with one extra constraint in orginal question you included equal heights bars in the area calculation here you had to avoid that, similar as LC 84 https://leetcode.com/problems/largest-rectangle-in-histogram/
Q2 : Similar to LC 1094 with large constraints expected O(N) solution
SDEII 的OA,两题九十分钟。
给一个数组,和一个int k。要求把数组分成k份,求每一份的中位数,然后加起来的最大和,如果有小数,则取上限。 [1,2,3,4,5],k=2 => [1,2,3,4], [5],和为2.5 + 5 = 8 (7.5) 解法,贪婪,k-1个组存前k-1个最大的数,剩下的数放最后一个子数组中
亚马逊服务器给定电量,求最长的cluster长度。 服务器是连续排列的,多个连续的服务器能形成一个cluster,运行一个cluster需要耗电。 给一个总电量maxPower,两个数组,一个是每个服务器的启动电量,一个是每个服务器的运行电量。问不超过maxPower的情况下最长的cluster长度是多少。 耗电量的计算方式是:cluster中启动电量最大的那个+每个服务器的运行电量和*cluster中服务器的数量。 maxPower = 25, bootingPower=[3,6,1,3,4], processingPower=[2,1,3,4,5] 最长cluster应该是[0,1,2]。 Max booting power = max(3,6,1) = 6 Sum of processing powers = 2 + 1 + 3 = 6 Net power consumption = 6 + 6 * 3 = 24 <= maxPower 解法,O(n)的滑动窗口,窗口内保存一个最大栈(monostack)来求窗口内的最max booting power。用窗口内processing power的和服务器数量来计算运行时的电量消耗。求加起来的总耗电量小于maxPower的最长cluster即为结果。 或者用O(nlgn)的二叉查找也能全部通过。对每个服务器,用二分查找,找到它最远能和前面的哪个服务器组成一个消耗小于max power的cluster。过程中用prefix sum计算processing power,用monostack存取并计算cluster的booting power(注意,在stack中找booting power的时候也要用二分查找,不然有4,5个test case过不了)、
地里老题 一个单链表长度为n, 求第 1 和 第 n, 第2 和 第n-1...的和, 以此类推,找出所有这些pairs和的max;
shipment Imbalance 变种, 实际上是求array中所有subarray, sort这些个subarray, 这些subarray中如果后一个比前一个element大于1, 那么这里存在一个imbalance, 问total number of imbalances. ;com/discuss/interview-question/1802061/
Last updated